<?php

namespace spec\BitBag\SyliusBonusPointsPlugin\Resolver;

use BitBag\SyliusBonusPointsPlugin\Calculator\DelegatingBonusPointsStrategyCalculatorInterface;
use BitBag\SyliusBonusPointsPlugin\Checker\Eligibility\BonusPointsStrategyEligibilityCheckerInterface;
use BitBag\SyliusBonusPointsPlugin\Repository\BonusPointsStrategyRepositoryInterface;
use BitBag\SyliusBonusPointsPlugin\Resolver\CartBonusPointsAmountResolver;
use BitBag\SyliusBonusPointsPlugin\Resolver\CartBonusPointsAmountResolverInterface;
use PhpSpec\ObjectBehavior;
use Sylius\Component\Core\Distributor\ProportionalIntegerDistributorInterface;

class CartBonusPointsAmountResolverSpec extends ObjectBehavior
{
    function it_is_a_cart_points_amount_resolver()
    {
        $this->shouldImplement(CartBonusPointsAmountResolverInterface::class);
    }

    function let(
        BonusPointsStrategyEligibilityCheckerInterface $bonusPointsStrategyEligibilityChecker,
        DelegatingBonusPointsStrategyCalculatorInterface $delegatingBonusPointsStrategyCalculator,
        BonusPointsStrategyRepositoryInterface $bonusPointsStrategyRepository,
        ProportionalIntegerDistributorInterface $proportionalIntegerDistributor
    )
    {
        $this->beConstructedWith(
            $bonusPointsStrategyEligibilityChecker,
            $delegatingBonusPointsStrategyCalculator,
            $bonusPointsStrategyRepository,
            $proportionalIntegerDistributor
        );
    }
}
