<?php

namespace spec\BitBag\SyliusBonusPointsPlugin\Twig\Extension;

use BitBag\SyliusBonusPointsPlugin\Resolver\BonusPointsResolverInterface;
use BitBag\SyliusBonusPointsPlugin\Resolver\CartBonusPointsAmountResolverInterface;
use PhpSpec\ObjectBehavior;
use Sylius\Component\Core\Model\OrderInterface;
use Twig\Extension\AbstractExtension;

class BonusPointsExtensionSpec extends ObjectBehavior
{
    function it_is_and_extension()
    {
        $this->shouldHaveType(AbstractExtension::class);
    }

    function let(
        BonusPointsResolverInterface $bonusPointsResolver,
        CartBonusPointsAmountResolverInterface $cartBonusPointsAmountResolver
    )
    {
        $this->beConstructedWith($bonusPointsResolver, $cartBonusPointsAmountResolver);
    }

    function it_resolves_the_active_bonus_points(
        BonusPointsResolverInterface $bonusPointsResolver
    )
    {
        $bonusPointsResolver
            ->resolveBonusPoints()
            ->shouldBeCalledOnce()
            ->willReturn(543);

        $this
            ->getActiveBonusPoints()
            ->shouldReturn(543);
    }

    function it_resolves_the_cart_bonus_points(
        CartBonusPointsAmountResolverInterface $cartBonusPointsAmountResolver,
        OrderInterface $order
    )
    {
        $cartBonusPointsAmountResolver
            ->resolveBonusPoints($order)
            ->shouldBeCalledOnce()
            ->willReturn(345);

        $this
            ->getCartBonusPointsAmount($order)
            ->shouldReturn(345);
    }
}
